
/*
          Horloge OSD
          
   F5MNA    Site http://f5mna.free.fr
      
   (V 0.0)  Décembre 2015
*/
#define DATAOUT 11//MOSI
#define DATAIN  12//MISO
#define SPICLOCK  13//sck
#define MAX7456SELECT 10//ss

//MAX7456 opcodes
#define DMM_reg   0x04
#define DMAH_reg  0x05
#define DMAL_reg  0x06
#define DMDI_reg  0x07
#define VM0_reg   0x00
#define VM1_reg   0x01

// video mode register 0 bits
#define VIDEO_BUFFER_DISABLE 0x01
#define MAX7456_RESET 0x02
#define VERTICAL_SYNC_NEXT_VSYNC 0x04
#define OSD_ENABLE 0x08
#define SYNC_MODE_AUTO 0x00
#define SYNC_MODE_INTERNAL 0x30
#define SYNC_MODE_EXTERNAL 0x20
#define VIDEO_MODE_PAL 0x40
#define VIDEO_MODE_NTSC 0x00

// video mode register 1 bits
// duty cycle is on_off
#define BLINK_DUTY_CYCLE_50_50 0x00
#define BLINK_DUTY_CYCLE_33_66 0x01
#define BLINK_DUTY_CYCLE_25_75 0x02
#define BLINK_DUTY_CYCLE_75_25 0x03

// blinking time
#define BLINK_TIME_0 0x00
#define BLINK_TIME_1 0x04
#define BLINK_TIME_2 0x08
#define BLINK_TIME_3 0x0C

// background mode brightness (percent)
#define BACKGROUND_BRIGHTNESS_0 0x00
#define BACKGROUND_BRIGHTNESS_7 0x01
#define BACKGROUND_BRIGHTNESS_14 0x02
#define BACKGROUND_BRIGHTNESS_21 0x03
#define BACKGROUND_BRIGHTNESS_28 0x04
#define BACKGROUND_BRIGHTNESS_35 0x05
#define BACKGROUND_BRIGHTNESS_42 0x06
#define BACKGROUND_BRIGHTNESS_49 0x07

#define BACKGROUND_MODE_GRAY 0x40

//MAX7456 commands
#define CLEAR_display 0x04
#define CLEAR_display_vert 0x06
#define END_string 0xff

// with PAL
// all VM0_reg commands need bit 6 set
#define ENABLE_display 0x48
#define ENABLE_display_vert 0x4c
#define MAX7456_reset 0x42
#define DISABLE_display 0x40


#define WHITE_level_80 0x03
#define WHITE_level_90 0x02
#define WHITE_level_100 0x01
#define WHITE_level_120 0x00

// with PAL
#define MAX_screen_size 480
#define MAX_screen_rows 16


//////////////////////////////////////////////////
//                   DS3232
//////////////////////////////////////////////////
#include <Wire.h>
#include <DS1307new.h>

int I2C_DS3232=0xD0 >> 1;
byte DS3232control=0b00011100, DS3232status=0b11001000 ,DS3232aging ,DS3232Msb ,DS3232Lsb;
uint16_t startAddr = 0x0000;       // Adresse de démarrage Start dans  NV-RAM
uint16_t lastAddr;                 // Nelle addresse des stockage NV-RAM
uint16_t TimeIsSet = 0xaa55;       // Prévient qu'il n'y a pas de remise à l'heure

  int H;
  int M;
  int S;
  int J;
  int Mo;
  int An;
  int JourSem;  
  
////////////////////////////
//   Boutons mise à l'heure
////////////////////////////
#define Touche_PIN  A3 // Entree platine Boutons
int Select;
int val_key, i;
int sensorPin = A3;  
int sensorValue = 1023; 
int val = 0;
int HidePin = 3;
//////////////////////////////////////////////////

void setup()
{
  Serial.begin (9600);
  byte spi_junk, eeprom_junk;
  int x;

  pinMode(MAX7456SELECT, OUTPUT);
  digitalWrite(MAX7456SELECT, HIGH); //disable device

  pinMode(DATAOUT, OUTPUT);
  pinMode(DATAIN, INPUT);
  pinMode(SPICLOCK, OUTPUT);

  SPCR = (1 << SPE) | (1 << MSTR);
  spi_junk = SPSR;
  spi_junk = SPDR;
  delay(250);

  digitalWrite(MAX7456SELECT, LOW);
  spi_transfer(VM0_reg);
  spi_transfer(MAX7456_reset);
  digitalWrite(MAX7456SELECT, HIGH);
  delay(500);

  digitalWrite(MAX7456SELECT, LOW);
  for (x = 0; x < MAX_screen_rows; x++)
  {
    spi_transfer(x + 0x10);
    spi_transfer(WHITE_level_90);
  }
  spi_transfer(VM0_reg);
  spi_transfer(VERTICAL_SYNC_NEXT_VSYNC | OSD_ENABLE);
  digitalWrite(MAX7456SELECT, HIGH);
  delay(100);
  spi_transfer(VM1_reg);
  spi_transfer(BLINK_DUTY_CYCLE_50_50 | BLINK_TIME_3);
  digitalWrite(MAX7456SELECT, HIGH);

  //////////////////////////////////////////////////////////

  pinMode(2, INPUT);                    // Test  SQW pin, D2 = INPUT
  digitalWrite(2, HIGH);                // Test  SQW pin, D2 = Pullup on
  RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entree startAddr in NV-RAM address 0x08
  TimeIsSet = 0xffff;
  RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
  RTC.ctrl = 0x00;     // 0x00=disable SQW pin, 0x10=1Hz,
  // 0x11=4096Hz, 0x12=8192Hz, 0x13=32768Hz
  RTC.setCTRL();

  pinMode( Touche_PIN, INPUT );         // A3  input
  digitalWrite( Touche_PIN, HIGH );     // A3  

  // OSD_write_to_screen( "f5mna  Granges-sur-Baume", 5, 30, 0, 0);  ///// Phrase pouvant être modifiée 
  // delay (100);
  }


  
/////////////////////////////////////////////////////////////
///                      HORLOGE                           //
/////////////////////////////////////////////////////////////
void Affichage()
{
 char Jour[4];
  dtostrf(J, 1, 0, Jour);

  char Mois[4];
  dtostrf(Mo, 1, 0, Mois);

  char Annee[8];
  dtostrf(An, 1, 0, Annee);

  if (  J > 9)  OSD_write_to_screen( Jour, 3, 2, 0, 0);
  if (J < 10)
  { OSD_write_to_screen( "0", 3, 2, 0, 0);
    OSD_write_to_screen(Jour, 4, 2, 0, 0);
  }
  OSD_write_to_screen( "/", 5, 2, 0, 0);

  if (  Mo > 9) OSD_write_to_screen( Mois, 6, 2, 0, 0);
  if (Mo < 10)
  { OSD_write_to_screen( "0", 6, 2, 0, 0);
    OSD_write_to_screen(Mois, 7, 2, 0, 0);
  }
   OSD_write_to_screen( "/", 8, 2, 0, 0);

  OSD_write_to_screen(Annee, 9, 2, 0, 0);

char Heure[4];
dtostrf(H, 1, 0, Heure);

char Minute[4];
dtostrf(M, 1, 0, Minute);

char Seconde[2];
dtostrf(S, 1, 0, Seconde);


if (H > 9) OSD_write_to_screen( Heure, 4, 3, 0, 0);
if (H < 10)
{ OSD_write_to_screen( "0", 4, 3, 0, 0);
  OSD_write_to_screen( Heure, 5, 3, 0, 0);
}
OSD_write_to_screen( ":", 6, 3, 0, 0);

if (M > 9) OSD_write_to_screen( Minute, 7, 3, 0, 0);
if (M < 10)
{ OSD_write_to_screen( "0", 7, 3, 0, 0);
  OSD_write_to_screen( Minute, 8, 3, 0, 0);
}
OSD_write_to_screen( ":", 9, 3, 0, 0);

if (S > 9) OSD_write_to_screen(Seconde, 10, 3, 0, 0);
if (S < 10) {
  OSD_write_to_screen( "0", 10, 3, 0, 0);
  OSD_write_to_screen(Seconde, 11, 3, 0, 0);
}

 switch (RTC.dow)                      
  {
    case 1:     
      OSD_write_to_screen(" Lundi  ", 4, 1, 0, 0);
      break;
    case 2:
      OSD_write_to_screen(" Mardi  ", 4, 1, 0, 0);
      break;
    case 3:
      OSD_write_to_screen("Mercredi", 4, 1, 0, 0);
      break;
    case 4:
      OSD_write_to_screen(" Jeudi  ", 4, 1, 0, 0);
      break;
    case 5:
      OSD_write_to_screen("Vendredi", 4, 1, 0, 0);
      break;
    case 6:
      OSD_write_to_screen(" Samedi ", 4, 1, 0, 0);
      break;
    case 0:
      OSD_write_to_screen("Dimanche", 4, 1, 0, 0);
      break;
      }  
}

void Mesuretemp()
{
 if  (Select == 0)  
 {  
 RTC.getTime();
 H = RTC.hour;
 M = RTC.minute;
 S = RTC.second;
 J = RTC.day;
 Mo = RTC.month;
 An = RTC.year; 
 }
  sensorValue = analogRead(sensorPin);    // lecture de la touche
  val_key = int(sensorValue/100);         // valeur entière de la touche / 10

////////////////////////////////////////////////////////
/////////// Selection des reglages /////////////////////
////////////////////////////////////////////////////////

   switch (val_key) 
       {
          case 0 : //Select 
          OSD_write_to_screen( " MISE A L'HEURE ", 7, 6, 0, 0);
       { 
         Select = (Select + 1);
         delay (200);
        }
         break;
       }
        if (Select == 1)  OSD_write_to_screen( "  REGLAGE  JOURS  ", 6, 8, 0, 0);      
     
        if (Select == 2)  OSD_write_to_screen( "   REGLAGE MOIS   ", 6, 8, 0, 0); 
 
        if (Select == 3)  OSD_write_to_screen( "  REGLAGE ANNEES  ", 6, 8, 0, 0); 
   
        if (Select == 4)  OSD_write_to_screen( "  REGLAGE HEURES  ", 6, 8, 0, 0); 
    
        if (Select == 5)  OSD_write_to_screen( " REGLAGE  MINUTES ", 6, 8, 0, 0); 
        
        if (Select == 6)  OSD_write_to_screen( " REGLAGES SECONDES", 6, 8, 0, 0); 
  
        if (Select == 7)  OSD_write_to_screen( "        TOP       ", 6, 8, 0, 0); 
  
        if (Select == 8){
           (Select = 0);
         RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entrée startAddr dans NV-RAM address 0x08 
            TimeIsSet = 0xffff;
            RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));         
            if (TimeIsSet != 0xaa55)
            {
             RTC.stopClock();        
             RTC.fillByYMD(An,Mo,J);
             RTC.fillByHMS(H,M,S);
             
    
             RTC.setTime();
             TimeIsSet = 0xaa55;
             RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
             RTC.startClock();
             OSD_write_to_screen("                  ", 6, 8, 0, 0); 
             OSD_write_to_screen("                ", 7, 6, 0, 0);
            }
            else
            {
             RTC.getTime();
        }   
       }
   
  switch (val_key)   
       {   
   case 3: //Down    /// (1023/5)x 1.58 = 315  //////////////////////////////////////////////////////////////
        { 
         delay (200);     
        if (Select == 1) {J = (J - 1);}  
        if (J < 1) {(J = 31);}
        if (Select == 2){ Mo = (Mo - 1);}
        if (Mo < 1) {(Mo = 12);} 
        if (Select == 3){An = (An - 1);}
       
        if (Select == 4) {H = (H - 1);}  
        if (H < 1) {(H = 23);}
        if (Select == 5){ M = (M - 1);}
        if (M < 1) {(M = 59);} 
        if (Select == 6){S = (S - 1);}
        if (S < 1) {(S = 59);}
        Affichage();
        }
        break;
        
  case 5: //UP  ////(1023/5) x 2.42 = 495 ////////////////////////////////////////////////////////////////////
        { 
     Serial.println (val_key);
     Serial.println (Select);    
     Serial.println (J);     
         delay (200);
        if (Select == 1) {J = (J + 1);}  
        if (J > 31) {(J = 1);}
        if (Select == 2){ Mo = (Mo + 1);}
        if (Mo > 12) {(Mo = 1);} 
        if (Select == 3){An = (An + 1);}
       
        if (Select == 4) {H = (H + 1);}  
        if (H > 23) {(H = 0);}
        if (Select == 5){ M = (M + 1);}
        if (M > 59 ) {(M = 0);} 
        if (Select == 6){S = (S + 1);}
        if (S > 59) {(S = 0);}
        Affichage();
        }
        break;
   }
   delay (200);
 }

//////////////////////////////////////////////////////////////
void Max7456 () {
  ////////////////////////////////////////////////////////////

  spi_transfer(VM0_reg);
  spi_transfer(VERTICAL_SYNC_NEXT_VSYNC | OSD_ENABLE | SYNC_MODE_AUTO);
  digitalWrite(MAX7456SELECT, HIGH);
}
byte convert_ascii (int character)
{

 byte lookup_char;
    if (character == 32)
    lookup_char = 0x00; // blank space
  else if (character == 48)
    lookup_char = 0x0a; // 0
  else if ((character > 48) && (character < 58))
    lookup_char = (character - 48); // 1-9
  else if ((character > 64) && (character < 91))
    lookup_char = (character - 54); // A-Z
  else if ((character > 96) && (character < 123))
    lookup_char = (character - 60); // a-z
  else if (character == 34)
    lookup_char = 0x48; // "
  else if (character == 39)
    lookup_char = 0x46; // '
  else if (character == 40)
    lookup_char = 0x3f; // (
  else if (character == 41)
    lookup_char = 0x40; // )
  else if (character == 44)
    lookup_char = 0x45; // ,
  else if (character == 45)
    lookup_char = 0x49; // -
  else if (character == 46)
    lookup_char = 0x41; // .
  else if (character == 47)
    lookup_char = 0x47; // /
  else if (character == 58)
    lookup_char = 0x44; // :
  else if (character == 59)
    lookup_char = 0x43; // ;
  else if (character == 60)
    lookup_char = 0x4a; // <
  else if (character == 62)
    lookup_char = 0x4b; // >
  else if (character == 63)
    lookup_char = 0x42; // ?
  else if (character == 64)
    lookup_char = 0x4c; // @
 //Modif tableau Std:  f5mna_3.mcm  
 //*********************************   
  else if (character == 43)
    lookup_char = 0x4e; // + 
  else if (character == 42)
    lookup_char = 0x4d ; // *    
  else if (character == 35)
    lookup_char = 0x51 ; // #    
  else if (character == 176)
    lookup_char = 0x4f ; // °     
  else if (character == 94)//^
    lookup_char = 0x50 ; // °C
 //********************************* 
 //    FLECHES  f5mna_4.mcm
 //********************************
  else if (character == 123) //Fléche montante
    lookup_char = 0x52 ;     // {  
  else if (character == 125) //Flèche descendante
    lookup_char = 0x53 ;     //}     
  else if (character == 168) //Flèche horizontale
    lookup_char = 0x54 ;     // ¨ tréma
 //********************************* 
 //    Pourcent  f5mna_6.mcm
 //********************************
  else if (character == 37)  // %
  lookup_char = 0x55 ;       // %
  
  else
    lookup_char = 0x00; 

 return (lookup_char);
}
byte spi_transfer(volatile byte data)
{
  SPDR = data;
  while (!(SPSR & (1 << SPIF)))
  {
  };
  return SPDR;
}

void OSD_write_to_screen(const char s[], byte x, byte y, byte blink, byte invert) {

  unsigned int linepos;
  byte local_count;
  byte settings, char_address_hi, char_address_lo;
  byte screen_char;

  local_count = 0;
  char_address_hi = 0;
  char_address_lo = 0;
  linepos = y * 30 + x;
  char_address_hi = linepos >> 8;
  char_address_lo = linepos;
  settings = B00000001;
  if (blink) {
    settings |= (1 << 4);
  }
  if (invert) {
    settings |= (1 << 3);
  }
  digitalWrite(MAX7456SELECT, LOW);
  spi_transfer(DMM_reg);
  spi_transfer(settings);

  spi_transfer(DMAH_reg);
  spi_transfer(char_address_hi);

  spi_transfer(DMAL_reg);
  spi_transfer(char_address_lo);

  while (s[local_count] != '\0')
  {
    screen_char = s[local_count];
    screen_char = convert_ascii(screen_char);
    spi_transfer(DMDI_reg);
    spi_transfer(screen_char);
    local_count++;
  }
  spi_transfer(DMDI_reg);
  spi_transfer(END_string);

  spi_transfer(VM0_reg);
  spi_transfer(ENABLE_display_vert);
  digitalWrite(MAX7456SELECT, HIGH);
}

void loop ()
{  

 val = digitalRead(HidePin);   // read the input pin

 if (val == 0)
 { 
 Mesuretemp();
 Affichage();
 Max7456();
 OSD_write_to_screen( "f5mna  Granges-sur-Baume", 5, 30, 0, 0);  ///// Phrase pouvant être modifiée 
 }
 else
 {
  OSD_write_to_screen("        ", 4, 1, 0, 0);
  OSD_write_to_screen("                ", 3, 2, 0, 0);
  OSD_write_to_screen("              ", 4, 3, 0, 0);
  OSD_write_to_screen("                        ", 5, 30, 0, 0);  ///// Phrase pouvant être modifiée 
 }
}
